/* VC */

/* Author: Illya Kovalevskyy
 * LGPL (C) 2012
 * illya.kovalevskyy@gmail.com
 * irc:freenode#kde-soc(tucnak)
 */
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>

using namespace std;

void read();
void write();
void solve();

class Point
{
public:
	Point(int x = 0, int y = 0) { m_x = x; m_y = y; }
	int x() const { return m_x; }
	int y() const { return m_y; }

private:
	int m_x;
	int m_y;
};

class Line
{
public:
	Line(const Point &a, const Point &b) : m_a(a), m_b(b) {}
	double A()
	{
		return (double)abs((m_a.y() - m_b.y()))+1;
	}
	double B()
	{
		return (double)abs((m_b.x() - m_a.x()))+1;
	}
	double C()
	{
		return (double)abs((-(A()*m_a.x() + B()*m_a.y())))+1;
	}

private:
	Point const m_a;
	Point const m_b;
};

int n;
vector<Point> plot;

int main()
{
	freopen("fortress.in", "r", stdin);
	freopen("fortress.out", "w", stdout);

	read();
	solve();

	return 0;
}

void read()
{
	cin >> n;

	// Number check
	if (n < 3) {
		cout << 0 << endl;
		exit(0);
	}

	for (int j = 0; j != n; j++) {
		int x, y;
		cin >> x >> y;
		Point pt(x, y);
		plot.push_back(pt);
	}
}

void solve()
{
	int slice = 0;
	for (int j = 0; j != n; j++) {
		for (int k = 0; k != n; k++) {
			for (int i = 0; i != n; i++) {
				if (j == k)
					break;
				if (j == i || k == i)
					continue;

				Line a = Line(plot[j], plot[k]);
				Line b = Line(plot[k], plot[i]);
				Line c = Line(plot[j], plot[i]);

				double qa = a.A()/b.A()/c.A();
				double qb = a.B()/b.B()/c.B();

				bool is = (qa == qb);
				if (is) {
					cout << 0 << endl;
					exit(0);
				}
			}
		}
	}
	cout << n << endl;
}
