/* VC */

/* Author: Illya Kovalevskyy
 * LGPL (C) 2012
 * illya.kovalevskyy@gmail.com
 * irc:freenode#kde-soc(tucnak)
 */
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <map>
#define INF 10000000

using namespace std;

struct Planet;

int n, m;
int ANSWER;
vector<Planet*> universe;
map<int, int> controller;

// Read and markup
// Markup:
//   * necessary sorting
//   * transformations
//   * structures
void read();

// Write answer integer
//   * ANSWER
void write();

void solve();

void cleanup();

int f(const int &a, const int &b) { return (a*1000)+(b*10); }

#define Link pair<int, int>
vector<Link> q;

struct Planet
{
	Planet() { SQL = INF; STA = false; }
	int planetId;
	int eachPortalCosts;
	vector<Planet*> links;
	vector<Link> _linksUsed;
	int SQL;
	bool STA;
};

int main()
{
	freopen("portals.in", "r", stdin);
	freopen("portals.out", "w", stdout);

	read();
	solve();
	write();
	cleanup();

	return 0;
}

bool isWay(Planet *from, Planet *to)
{
	for (int k = 0; k < (int)from->links.size(); k++) {
		cout << k << " " << from->links.size() << endl;
		if (from->links[k] != to) {
			bool is = isWay(from->links[k], to);
			if (is)
				return true;
		} else {
			return true;
		}
	}

	return false;
}

void findAllNotConnected()
{
	for (int j = 0; j < n; j++) {
		for (int k = 0; k < j; k++) {
			if (!isWay(universe[j], universe[k])) {
				Link nt;
				nt.first = j;
				nt.second = k;
				q.push_back(nt);
			}
		}

		for (int k = j+1; k < n; k++) {
			if (!isWay(universe[j], universe[k])) {
				Link nt;
				nt.first = j;
				nt.second = k;
				q.push_back(nt);
			}
		}
	}
}

void read()
{
	cin >> n >> m;

	for (int j = 0; j < n; j++) {
		universe.push_back(new Planet);
	}

	for (int j = 0; j < n; j++) {
		Planet *dodo = universe[j];
		dodo->planetId = j;
		int c;
		cin >> c;
		if (c == 0) {
			dodo->eachPortalCosts = -1;
		} else {
			dodo->eachPortalCosts = c;
		}
	}

	vector< pair<int, int> > usedThere;

	for (int j = 0; j < m; j++) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		controller[ f(a, b) ] = -5;
		controller[ f(b, a) ] = -5;
		usedThere.push_back(pair<int, int>(a, b));
	}

	findAllNotConnected();

	int s = 0;

	for (int j = 0; j < n; j++) {
		for (int k = s; k < j; k++) {
			Planet *a = universe[j];
			Planet *b = universe[k];

			if (a->eachPortalCosts < 0 && b->eachPortalCosts < 0) {
				controller[ f(a->planetId, b->planetId) ] = 0;
				controller[ f(b->planetId, a->planetId) ] = 0;
			} else if (controller[ f(a->planetId, b->planetId) ] != -5) {
				controller[ f(a->planetId, b->planetId) ] = a->eachPortalCosts + b->eachPortalCosts;
				controller[ f(b->planetId, a->planetId) ] = a->eachPortalCosts + b->eachPortalCosts;
			}

			a->links.push_back(b);
			b->links.push_back(a);
		}
		
		for (int k = j+1; k < n; k++) {
			Planet *a = universe[j];
			Planet *b = universe[k];

			if (a->eachPortalCosts < 0 && b->eachPortalCosts < 0) {
				controller[ f(a->planetId, b->planetId) ] = 0;
				controller[ f(b->planetId, a->planetId) ] = 0;
			} else  if (controller[ f(a->planetId, b->planetId) ] != -5) {
				controller[ f(a->planetId, b->planetId) ] = a->eachPortalCosts + b->eachPortalCosts;
				controller[ f(b->planetId, a->planetId) ] = a->eachPortalCosts + b->eachPortalCosts;
			}

			a->links.push_back(b);
			b->links.push_back(a);
		}
		s++;
	}

	for (int j = 0; j < (int)usedThere.size(); j++) {
		int a = usedThere[j].first;
		int b = usedThere[j].second;

		controller[ f(a, b) ] = 0;
		controller[ f(b, a) ] = 0;
	}
}

vector<Link> p;

bool isThere(const Link &a) {
	int c = 0;
	for (int j = 0; j < (int)p.size(); j++) {
		if (p[j] == a) {
			c++;
		}
	}

	return (c > 0);
}

void useLink(const Link &link) {
	Planet *gogo = universe[link.first];
	gogo->SQL = 0;
	gogo->STA = true;

	while (gogo != universe[link.second]) {
		for (int j = 0; j < (int)gogo->links.size(); j++) {
			Planet *moo = gogo->links[j];
			int was = moo->SQL;
			int canbe = gogo->SQL + controller[f(moo->planetId, gogo->planetId)];
			if (was > canbe) {
				moo->SQL = canbe;
				moo->_linksUsed = gogo->_linksUsed;
				Link newLink;
				newLink.first = gogo->planetId;
				newLink.second = moo->planetId;
				moo->_linksUsed.push_back(newLink);
			}
		}

		int minId = -1;
		int minVal = INF;
		for (int j = 0; j < n; j++) {
			if (!universe[j]->STA && universe[j]->SQL < minVal) {
				minVal = universe[j]->SQL;
				minId = j;
			}
		}
		if (minId != -1) {
			gogo = universe[minId];
			gogo->STA = true;
		} else {
			cout << 0 << endl;
			cleanup();
			exit(0);
		}
	}

	for (int j = 0; j < gogo->_linksUsed.size(); j++) {
		if (!isThere(gogo->_linksUsed[j]))
			p.push_back(gogo->_linksUsed[j]);
	}
}

void cleanTemp() {
	for (int j = 0; j < n; j++) {
		universe[j]->_linksUsed.clear();
		universe[j]->SQL = 0;
		universe[j]->STA = false;
	}
}

void theShortestWay()
{
	for (int j = 0; j < (int)q.size(); j++) {
		useLink(q[j]);
		cleanTemp();
	}
}

void solve()
{
	for (int j = 0; j < (int)q.size(); j++) {
		theShortestWay();
	}
}

void write()
{
	ANSWER = 0;
	for (int j = 0; j < (int)p.size(); j++) {
		ANSWER += controller[f(p[j].first, p[j].second)];
	}
	cout << ANSWER << endl;
}

void cleanup()
{
	for (int j = 0; j < n; j++)
		delete universe[j];
}
