/* GCC */
#include <stdio.h>
#include <algorithm>
#include <vector>

#define mp make_pair
#define pb push_back

using std::vector;
using std::pair;
using std::sort;
using std::swap;
using std::mp;

__int64 cost;
int n, m, costs[1010], x, y, temp, p[1010];
vector < pair < int, pair < int, int > > > edge;

int dsu_get(int v)
{
	return (v == p[v]) ? v : (p[v] = dsu_get(p[v]));
}

void dsu_union(int a, int b)
{
	a = dsu_get(a);
	b = dsu_get(b);
	if(a % 2)
		swap(a, b);
	
	if(a != b)
		p[a] = b;
}

void read()
{
	scanf("%d %d", &n, &m);
	for(int i = 0; i < n; ++i)
	{
		scanf("%d", costs + i);
		p[i] = i;
	}
	
	for(int i = 0; i < m; ++i)
	{
		scanf("%d %d", &x, &y); x--, y--;
		dsu_union(x, y);
	}
	
	for(int i = 0; i < n - 1; ++i)	
		for(int j = 0; j < n; ++j)
			if(i != j)
				edge.pb(mp(costs[i] + costs[j], mp(i, j)));
	
	m = edge.size();
	sort(edge.begin(), edge.end());
}

void solve()
{
	for(int i = 0; i < m; ++i)
	{
		x = edge[i].second.first; y = edge[i].second.second; temp = edge[i].first;
		
		if(dsu_get(x) != dsu_get(y))
		{
			cost += temp;
			dsu_union(x, y);
		}
	}
	
	printf("%I64d\n", cost);
}

int main()
{
	freopen("portals.in", "r", stdin);
	freopen("portals.out", "w", stdout);
	
	read();
	solve();
	
	return 0;
}
