{ Free Pascal }

program portals;

type pPlanet = ^planet; {pointer to record -  planet}
     planet=record
        number : integer; {number of planet in array}
        cost : longint;   {cost of portal on this palnet}
        linked : integer; {how many portals (links to other planets) are there on this planet}
        links : array [1..1000] of pPlanet; {array of pointers (links) to other planets}
     end;

var planets : array [1..1000] of planet;
var network : array [1..2002] of integer; {array, where groups of planets are stored; groups are divided by '0' - (0 1 2 0 3 4 0)}
var mins : array [1..1000] of longint; {array of minimal costs on groups}
var f : text;
var m, n, i, a, b, globalIterator, iMin, answer : longint;
{globalItearator points on current place in network array}

{function finds minimal cost on group}
{it it takes from which element to search and stops on '0'}
function min(start : integer) : longint;
var j : integer;
var quit : boolean;
begin
        j:=start; quit:=false; min:=planets [ network [start] ].cost;
        while quit=false do
                begin
                        if planets [network [j]].cost < min then
                                min := planets [network [j]].cost;
                        inc(j);
                        if network [j] = 0 then
                                quit:=true;
                end;
end;

{function checks, if planet with number 'number' exists in network}
function notRepeated(number : integer) : boolean;
var j : integer;
begin
        notRepeated:=true;
        for j:=1 to globalIterator do
                if network [j] = number then
                        notRepeated:=false;
end;

{procedure takes the number of planet and processes its links}
{recursively, this procedure goes through all planets of group}
{and stores in network array these planets}
procedure recurse(number : integer);
var j : integer;
begin
        {if planet is alone (has not any portals), we may store it}
        {in network array immediately}
        if planets [number].linked=0 then
                begin
                        inc(GlobalIterator);
                        network [globalIterator] := planets [number].number;
                end;
        {go through all links of current planet}
        {do not go to planet, which is already in network array}
        {examine every linked planet}
        for j:=1 to planets [number].linked do
                if ( notRepeated(planets [number].links[j]^.number)=true) then
                        begin
                                inc(globalIterator);
                                network [globalIterator] := planets [number].links[j]^.number;
                                recurse(planets [number].links [j]^.number);
                        end;
end;

begin
{The task is the following:
        1. read information and create kinks
        2. analyze links and divide planets into groups
        3. find minimal cost of portal on each group (portals are already built in groups)
        4. add them
This way we build portals between 'the cheepest' planets
One may get to such 'cheep' planet by already built portals inside group
Then go to necessary group by new portals
Then go to destination from 'cheep' planet by portals inside gruop}


        assign(f, 'portals.in'); reset(f);
        readln(f, n, m);

        for i:=1 to n do
                begin
                        read(f, planets [i].cost);
                        planets [i].linked:=0;
                        planets [i].number:=i;
                end;

        {using the information from file, create double links}
        {between planets}
        for i:=1 to m do
                begin
                        readln(f, a, b);

                        inc(planets [a].linked);
                        inc(planets [b].linked);

                        new(planets [a].links [planets [a].linked]);
                        new(planets [b].links [planets [b].linked]);

                        planets [a].links [planets [a].linked]^ := planets [b];
                        planets [b].links [planets [b].linked]^ := planets [a];
                end;
        close(f);

        {init variables}
        network[1]:=0;
        globalIterator:=1;

        {examine all planets to store them in groups}
        for i:=1 to n do
                if notRepeated(i)=true then
                        begin
                                recurse(i);
                                inc(globalIterator);
                                network [globalIterator]:=0;
                        end;


        {find the minium cost of portal in every group}

        iMin:=0;

        for i:=1 to globalIterator do
                if (network [i]=0) and (network[i+1]<>0) then
                        begin
                                inc(iMin);
                                mins [iMin]:=min(i+1);
                        end;

        {calculate answer by adding min costs}

        answer:=0;

        for i:=1 to iMin do
                answer:=answer+mins [i];

        {if all planets are already connected, we do not have to spend money}
        if iMin=1 then
                answer:=0;


        assign(f, 'portals.out'); rewrite(f);
        writeln(f, answer); close(f);

end.















































{

--- DEBUG ---

program portals;
type pPlanet = ^planet;
planet=record
        number : integer;
        cost : longint;
        linked : integer;
        links : array [1..1000] of pPlanet;
end;

var planets : array [1..1000] of planet;
var network : array [1..2000] of integer;
var mins : array [1..1000] of integer;
var f : text;
var m, n, i, a, b, globalIterator, iMin, answer : longint;
var s : planet;
var p : pPlanet;

function min(start : integer) : integer;
var j : integer;
var quit : boolean;
begin
        j:=start; quit:=false; min:=planets [ network [start] ].cost;
        writeln('start');
        while quit=false do
                begin
                        writeln(planets [network [j]].cost);
                        if planets [network [j]].cost < min then
                                begin
                                        min := planets [network [j]].cost;
                                        writeln('new min - ', min); readln;
                                end;
                        inc(j);
                        if network [j] = 0 then
                                quit:=true;
                end;
end;

function notRepeated(number : integer) : boolean;
var j : integer;
begin
        notRepeated:=true;
        for j:=1 to globalIterator do
                if network [j] = number then
                        notRepeated:=false;
end;

procedure recurse(prev, number : integer);
var j : integer;
begin
        if planets [number].linked=0 then
                begin
                        inc(GlobalIterator);
                        network [globalIterator] := planets [number].number;
                end;
        writeln; writeln;
        writeln('Planet - ', number, ' from - ', prev, ' has - ', planets [number].linked, ' links'); readln;
        for j:=1 to planets [number].linked do
                begin
                        if ( notRepeated(planets [number].links[j]^.number)=true planets [number].links[j]^.number <> planets [prev].number) then
                                begin
                                        inc(globalIterator); writeln('globalIterator was increased to ', globalIterator);
                                        network [globalIterator] := planets [number].links[j]^.number;
                                        recurse(number, planets [number].links [j]^.number);
                        end;
                end;
end;

begin
        for i:=1 to 1 do
                writeln('Hellllo');

        assign(f, 'portals.in'); reset(f);
        readln(f, n, m);

        for i:=1 to n do
                begin
                        read(f, planets [i].cost);
                        planets [i].linked:=0;
                        planets [i].number:=i;
                end;

        for i:=1 to m do
                begin
                        readln(f, a, b);
                        inc(planets [a].linked);
                        inc(planets [b].linked);
                        new(planets [a].links [planets [a].linked]);
                        new(planets [b].links [planets [b].linked]);
                        planets [a].links [planets [a].linked]^ := planets [b];
                        planets [b].links [planets [b].linked]^ := planets [a];
                end;
        close(f);

        network[1]:=0;
        globalIterator:=1;
        for i:=1 to n do
                begin
                        if notRepeated(i)=true then
                                begin
                                        recurse(i, i);

                                        inc(globalIterator); network [globalIterator]:=0;
                                end;
                end;

        globalIterator:=0;
        network[1]:=1;
        recurse(1, 1);
        writeln(globalIterator); readln;
        for i:=1 to globalIterator do
                write(network[i], ' ');
        iMin:=0;
        for i:=1 to globalIterator do
                begin
                        if (network [i]=0) and (network[i+1]<>0) then
                                begin
                                        inc(iMin);
                                        mins [iMin]:=min(i+1);
                                end;
                end;

                writeln; writeln;
        for i:=1 to iMin do
                write(mins[i], ' ');

        answer:=0;
        for i:=1 to iMin do
                answer:=answer+mins [i];

                writeln('ANSWEEER - ', answer);

        readln;



end }
