/* GCC */
#include <vector>
#include <iostream>
#include <algorithm>

#define PB push_back
#define W first
#define X second.first
#define Y second.second

using namespace std;

bool used[1010];
int n, m, a, b, p_x, p_y, comp_sz = 0, edge_sz = 0, p[1010], min_pc[1010], rank[1010], suf[1010];
long long ans = 0;
pair < int, pair < int, int > > edge[1000100];
vector < int > gr[1010], comp[1010];

int find( int v )
{
    int start = v, p;
    while( suf[v] != v ) v = suf[v];
    p = v;
    while( suf[start] != start ) v = suf[start], suf[start] = p, start = v;
    return p; 
}

void union_tree( int f, int s )
{
     if( rank[f] >= rank[s] ) suf[s] = f, rank[f] += rank[s]; else suf[f] = s, rank[s] += rank[f];
     return;
}

void dfs( int u )
{
     comp[comp_sz].PB( u );
     used[u] = 1;
     for( int i = 0; i < gr[u].size(); i++ )
     {
          if( used[gr[u][i]] == 0 ) dfs( gr[u][i] );
     }
     return;
}

int main()
{
    freopen("portals.in", "r", stdin);
    
    scanf("%d%d", &n, &m);
    for( int i = 1; i <= n; i++ ) scanf("%d", &p[i]);
    for( int i = 0; i < m; i++ ) scanf("%d%d", &a, &b), gr[a].PB( b ), gr[b].PB( a );
    
    memset( used, 0, 1010 );
    for( int i = 1; i <= n; i++ )
    {
         if( used[i] == 0 ) dfs( i ), comp_sz++;
    }
    
    int min;
    for( int i = 0; i < comp_sz; i++ )
    {
         min = 1001000;
         for( int j = 0; j < comp[i].size(); j++ ) if( p[comp[i][j]] < min ) min = p[comp[i][j]];
         min_pc[i] = min;
    }
    comp_sz--;
    for( int i = 0; i < comp_sz; i++ )
    {
         for( int j = i + 1; j <= comp_sz; j++ )
         {
              edge[edge_sz].W = min_pc[i] + min_pc[j];
              edge[edge_sz].X = i;
              edge[edge_sz].Y = j;
              edge_sz++;
         }
    }
    sort( &edge[0], &edge[edge_sz] );
    for( int i = 0; i <= comp_sz; i++ ) suf[i] = i, rank[i] = 1;
    
    for( int i = 0; i < edge_sz; i++ )
    {
         p_x = find( edge[i].X );
         p_y = find( edge[i].Y );
         if( p_x != p_y ) ans += edge[i].W, union_tree( p_x, p_y );
    }
    
    fclose(stdin);
    
    freopen("portals.out", "w", stdout);
    cout << ans << endl;
    fclose(stdout);
    return 0;
}
