/* GCC */
#include <iostream>
#include <stdio.h>
#include <math.h>
#include <string>
#include <string.h>
#include <algorithm>
#include <vector>

using namespace std;

const int MAXN = 1010;
const int MAXM = MAXN * MAXN;
const int INF = (int)1e9;

int N, M;

long long ans;

int a, b;
int part[MAXN];
vector < vector < int > > g;
bool used[MAXN];
int color;
int opt[MAXN];
int cost[MAXN];

void dfs(int v)
{
	used[v] = true;
	if (cost[v] < opt[color])
		opt[color] = cost[v];
	for (int i = 0; i < (int)g[v].size(); ++i)
	{
		int to = g[v][i];
		if (!used[to])
			dfs(to);
	}
}

int main()
{
	freopen("portals.in", "r", stdin);
	freopen("portals.out", "w", stdout);
	scanf("%d %d", &N, &M);
	g.resize(N);
	for (int i = 0; i < N; ++i) scanf("%d", &cost[i]);
	for (int i = 0; i < M; ++i)
	{
		scanf("%d %d", &a, &b);
		g[a - 1].push_back(b - 1);
		g[b - 1].push_back(a - 1);
	}
	
	opt[color] = INF;
	for (int i = 0; i < N; ++i)
	{
		if (!used[i])
		{
			dfs(i);
			++color;
			opt[color] = INF;
		}
	}
	sort(opt, opt + color);
	for (int i = 1; i < color; ++i)
		ans += (opt[0] + opt[i]);
	cout << ans << endl;
}