/* GCC */
//#include<iostream>
#include<fstream>
#include<math.h>

#define MAXN 5
#define MAXM 20
#define P 41

using namespace std;

inline bool isSuperset(int A, int B) {
    return ((~A) & B) == 0;
}

long long nested(int m, int h[MAXN], int start, int end, int sStart, int sEnd) {
    //cout << "nested(" << m << ", h, " << start << ", " << end << ", " << sStart << ", " << sEnd << ");\n";
    long long res = 0;
    if (end - start == 0) return sStart == sEnd;
    if (end - start == 1) return isSuperset(sStart, sEnd);
    int middle = (start + end) / 2;
    for (int i = sEnd / P; i <= sStart / P; i++) {
        int sMiddle = i * P + h[middle];
        if (isSuperset(sStart, sMiddle) && isSuperset(sMiddle, sEnd)) {
            //if (sStart == (1 << m) - 1 && sEnd == 0) cout << i << " ";
            long long left = 0;
            long long right = 0;
            if (sMiddle < (sStart + sEnd) / 2) {
                right = nested(m, h, middle, end, sMiddle, sEnd);
                if (right != 0) left = nested(m, h, start, middle, sStart, sMiddle);
            } else {
                left = nested(m, h, start, middle, sStart, sMiddle);
                if (left != 0) right = nested(m, h, middle, end, sMiddle, sEnd);
            }
            res += left * right;
        }
    }
    return res;
}

int main() {
    int n, m;
    int h[MAXN];
    
    ifstream fin("nested.in");
    fin >> n >> m;
    for (int i = 0; i < n; i++) fin >> h[i];
    fin.close();

    long long res = nested(m, h, -1, n, (1 << m) - 1, 0);
    //cout << "\n";
    ofstream fout("nested.out");
    fout << res << "\n";
    fout.close();

    //cin.get();
    //cin.get();

    return 0;
}
