/* GCC */
//#include<iostream>
#include<fstream>
#include<vector>
#include<math.h>

#define MAXN 1000

using namespace std;

long long dfs(vector<int> graph[MAXN], long long prices[MAXN], int v, bool visited[MAXN]) {
    long long res = prices[v];
    visited[v] = true;
    for (int i = 0; i < graph[v].size(); i++) {
        int v1 = graph[v][i];
        if (!visited[v1]) {
            res = min(res, dfs(graph, prices, v1, visited));
        }
    }
    return res;
}

int main() {
    int n, m;
    long long prices[MAXN];
    vector<int> graph[MAXN];
    
    ifstream fin("portals.in");
    fin >> n >> m;
    for (int i = 0; i < n; i++) fin >> prices[i];
    for (int i = 0; i < m; i++) {
        int a, b;
        fin >> a >> b;
        graph[a - 1].push_back(b - 1);
        graph[b - 1].push_back(a - 1);
    }
    fin.close();
    
    int components = 0;
    long long minPrices[MAXN];
    bool visited[MAXN];
    for (int i = 0; i < n; i++) {
        visited[i] = false;
    }
    for (int i = 0; i < n; i++) {
        if(!visited[i]) {
            minPrices[components] = dfs(graph, prices, i, visited);
            components++;
        }
    }

    long long minPrice = minPrices[0];
    for (int i = 1; i < components; i++) {
        minPrice = min(minPrice, minPrices[i]);
    }
    
    long long res = (components - 2) * minPrice;
    for (int i = 0; i < components; i++) {
        res += minPrices[i];
    }

    ofstream fout("portals.out");
    fout << res << "\n";
    fout.close();

    //cin.get();
    //cin.get();

    return 0;
}
