/* VC */

#include <fstream>
#include <vector>

const int k = 41;

const int binary[] = {1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,
					  16384,32768,65536,131072,262144,524288,1048576};

bool check(const std::vector<int>& h,const std::vector<unsigned int>& s)
{
	for(int i = 0;i < h.size();i++)
		if((s[i+1] % k) != h[i])
			return false;
	return true;
}

bool isSubset(unsigned int set,unsigned int subset)
{
	for(int i = 0;(set >> i) != 0;i++)
		if((set & binary[i]) < (subset & binary[i]))
			return false;
	return true;
}

void p(const std::vector<int>& h,std::vector<unsigned int>& s,
	   int position,unsigned long long& counter)
{
	if(position == s.size())
	{
		if(check(h,s))
			++counter;
		return;
	}
	for(int i = 0;i <= s[position-1];i++)
	{
		if(isSubset(s[position-1],i))
		{
			s[position] = i;
			p(h,s,position+1,counter);
		}
	}
}

unsigned long long calculate(const std::vector<int>& h,int m)
{
	unsigned long long answer = 0;
	std::vector<unsigned int> s(h.size()+1);
	s[0] = binary[m]-1;
	p(h,s,1,answer);
	return answer;
}

int main()
{
	std::ifstream in("nested.in");
	int n,m;
	in >> n >> m;
	std::vector<int> h(n);
	for(int i = 0;i < h.size();i++)
		in >> h[i];
	in.close();
	std::ofstream out("nested.out");
	out << calculate(h,m) << std::endl;
	out.close();
}