/* VC */

#include <fstream>
#include <vector>

void dfs(const std::vector<std::vector<int> >& graph,const std::vector<int>& cost,
		 std::vector<bool>& used,int& root,int current)
{
	used[current] = true;
	if(cost[current] < cost[root])
		root = current;
	for(int i = 0;i < graph[current].size();i++)
		if(!used[graph[current][i]])
			dfs(graph,cost,used,root,graph[current][i]);
}

void findRoot(const std::vector<std::vector<int> >& graph,
			  const std::vector<int>& cost,std::vector<int>& root)
{
	std::vector<bool> used(graph.size());
	int position = 0;
	while(position != graph.size())
	{
		root.push_back(position);
		dfs(graph,cost,used,root.back(),position);
		while(position != graph.size() && used[position])
			++position;
	}
}

int main()
{
	std::ifstream in("portals.in");
	int n,m;
	in >> n >> m;
	std::vector<std::vector<int> > graph(n);
	std::vector<int> cost(n);
	for(int i = 0;i < cost.size();i++)
		in >> cost[i];
	for(int i = 0;i < m;i++)
	{
		int a,b;
		in >> a >> b;
		graph[a-1].push_back(b-1);
		graph[b-1].push_back(a-1);
	}
	in.close();
	std::vector<int> root;
	findRoot(graph,cost,root);
	for(int i = 0;i < root.size()-1;i++)
		if(cost[root[i]] < cost[root[i+1]])
			std::swap(root[i],root[i+1]);
	unsigned int sum = 0;
	for(int i = 0;i < root.size()-1;i++)
		sum += cost[root[i]];
	sum += (root.size()-1)*cost[root.back()];
	std::ofstream out("portals.out");
	out << sum << std::endl;
	out.close();
}