/* VC */
#include <cstdio>
#include <algorithm>
#include <vector>

using namespace std;

const int NMAX = 111;
const int infinity = 1000000000;

int N , GlobalAnswer = 0;

struct frac
{
	int a , b;
	frac(){};
	frac(int _a , int _b) : a(_a) , b(_b) {
		if ( !b )
			b = 1 , a = (a < 0) ? -infinity : 0;
	};
};

bool operator <(frac X , frac Y)
{
	return X.a * 1ll * Y.b < X.b * 1ll * Y.a;
};

bool operator ==(frac X , frac Y)
{
	return X.a * 1ll * Y.b == X.b * 1ll * Y.a;
};

struct point
{
	int x , y , Dist;
	frac Angle;
} S[NMAX];

bool operator <(point Pi , point Pj)
{
	return (Pi.Angle < Pj.Angle) || (Pi.Angle == Pj.Angle && Pi.Dist < Pj.Dist);
};

bool Check(point Pi , point Pj , point Pk)
{
	return (Pj.x - Pi.x) * (Pj.y - Pk.y) - (Pj.y - Pi.y) * (Pj.x - Pk.x) > 0;
};

bool CheckLine(point Pi , point Pj , point Pk)
{
	return (Pk.x - Pj.x) * (Pj.y - Pi.y) == (Pk.y - Pj.y) * (Pj.x - Pi.x);
};

bool Used[NMAX];

int main()
{
	freopen("fortress.in","r",stdin);
	freopen("fortress.out","w",stdout);
	scanf("%d",&N);
	for (int i = 0 ; i < N ; i ++ )
		scanf("%d%d",&S[i].x,&S[i].y);
	bool OneLine = true;
	for (int i = 2 ; i < N ; i ++ )
		if ( !CheckLine(S[0] , S[1] , S[i]) )
		{
			OneLine = false;
			break;
		};
	if ( OneLine )
	{
		printf("0\n");
		return 0;
	};
	for ( ; ; )
	{
		vector <point> Cur;
		int MinID = 0;
		for (int i = 0 ; i < N ; i ++ )
			if ( !Used[i] )
			{
				Cur.push_back(S[i]);
				if ( Cur.back().y < Cur[MinID].y || (Cur.back().y == Cur[MinID].y && Cur.back().x < Cur[MinID].x) )
					MinID = i;
			};
		if ( Cur.size() < 3 )
			break;
		swap(Cur[0] , Cur[MinID]);
		for (int i = 0 ; i < Cur.size() ; i ++ )
		{
			Cur[i].Dist = (Cur[i].x - Cur[0].x) * (Cur[i].x - Cur[0].x) + (Cur[i].y - Cur[0].y) * (Cur[i].y - Cur[0].y);
			Cur[i].Angle = frac(Cur[0].x - Cur[i].x , Cur[i].y - Cur[0].y);
		};
		sort(Cur.begin() + 1 , Cur.end());
		vector <int> ConvexHull;
		ConvexHull.push_back(0);
		ConvexHull.push_back(1);
		for (int i = 2 ; i < Cur.size() ; i ++ )
		{
			while ( ConvexHull.size() > 1 && !Check(Cur[i] , Cur[ConvexHull.back()] , Cur[ConvexHull[ConvexHull.size() - 2]]) )
				ConvexHull.pop_back();
			ConvexHull.push_back(i);
		};
		ConvexHull.push_back(0);
		int answer = 0;
		for (int i = 0 ; i < N ; i ++ )
			for (int j = 0 ; j < ConvexHull.size() - 1 ; j ++ )
				if ( CheckLine(S[i] , Cur[ConvexHull[j]] , Cur[ConvexHull[j + 1]]) )
				{
					answer ++ ;
					Used[i] = true;
					break;
				};
		GlobalAnswer = max(GlobalAnswer , answer);
	};
	printf("%d\n",GlobalAnswer);
	return 0;
};