/* VC */
#include <cstdio>
#include <algorithm>

using namespace std;

const int NMAX = 1111;

struct Edge
{
	int u , v , cost;
	Edge(){};
	Edge(int _u , int _v , int _cost) : u(_u) , v(_v) , cost(_cost) {};
} E[NMAX * NMAX];

bool operator <(Edge Ei , Edge Ej)
{
	return Ei.cost < Ej.cost;
};

int N , M , Cost[NMAX] , Color[NMAX] , CompSize[NMAX] , Ecnt;

int GetRoot(int v)
{
	if ( Color[v] == v )
		return v;
	return Color[v] = GetRoot(Color[v]);
};

void unite(int v , int u)
{
	v = GetRoot(v);
	u = GetRoot(u);
	if ( v != u )
	{
		if ( CompSize[v] < CompSize[u] )
			swap(v , u);
		Color[u] = v;
		CompSize[v] += CompSize[u];
	};
};

int main()
{
	freopen("portals.in","r",stdin);
	freopen("portals.out","w",stdout);
	scanf("%d%d",&N,&M);
	for (int i = 1 ; i <= N ; i ++ )
		Color[i] = i , CompSize[i] = 1;
	for (int i = 1 ; i <= N ; i ++ )
		scanf("%d",&Cost[i]);
	for (int i = 1 ; i <= M ; i ++ )
	{
		int v , u;
		scanf("%d%d",&v,&u);
		unite(v , u);
	};
	for (int i = 1 ; i <= N ; i ++ )
		for (int j = i + 1 ; j <= N ; j ++ )
			if ( GetRoot(i) != GetRoot(j) )
			E[Ecnt ++ ] = Edge(i , j , Cost[i] + Cost[j]);
	sort(E , E + Ecnt);
	int Answer = 0;
	for (int i = 0 ; i < Ecnt ; i ++ )
	{
		int u = E[i].u , v = E[i].v;
		if ( GetRoot(u) != GetRoot(v) )
		{
			Answer += E[i].cost;
			unite(u , v);
		};
	};
	printf("%d\n",Answer);
	return 0;
};