/* GCC */
#include "fstream"

#define max_n 1000

using namespace std;

long int p[max_n], j, m, cost = 0;
int n, i, k, from, to;
bool data[max_n][max_n];

bool hasPortal(int from, int to) {
     int k;
     for (k = 0; k < n; k++) {
         if (data[to][k] && data[k][from])
             return true;
     }
     return false;
}

void rebuildData() {
    for (i = 0; i < n; i++)
        for (k = 0; k < n; k++)
            if (!data[i][k] && hasPortal(i, k)) {
               data[i][k] = 1;
               data[k][i] = 1;
            }
}

void moveRow(int row, int to) {
     bool temp;
     int i;
     for (i = 0; i < n; i++) {
         temp = data[row][i];
         data[row][i] = data[to][i];
         data[to][i] = temp;
     }
     for (i = 0; i < n; i++) {
         temp = data[i][row];
         data[i][row] = data[i][to];
         data[i][to] = temp;
     }
}

void qsort(int l, int r) {
     int i = l, j = r, b = p[(l + r) / 2];
     while (i <= j) {
         while (p[i] < b) i++;
         while (p[j] > b) j--;
         if (i < j) {
             int temp = p[i];
             p[i] = p[j];
             p[j] = temp;
             moveRow(i, j);
         }
         i++; j--;
     }
     if (i < r) qsort(i, r);
     if (j > l) qsort(l, j);
}

int main() {
    ifstream f_in("portals.in");
    ofstream f_out("portals.out");
    f_in >> n >> m;
    for (i = 0; i < n; i++) {
        f_in >> p[i];
        data[i][i] = true;
    }
    for (j = 0; j < m; j++) {
        f_in >> from >> to;
        data[from - 1][to - 1] = true;
        data[to - 1][from - 1] = true;
    }
    qsort(0, n - 1);
    rebuildData();
    for (i = 0; i < n; i++)
        for (k = 0; k < n; k++)
            if (!data[i][k]) {
                data[i][k] = true;
                data[k][i] = true;
                cost += p[i] + p[k];
                rebuildData();
            }
    f_out << cost << endl;
}
